﻿-----
-- LibDataBroker data-source
-- TODO: Clean the code up
----
local UPDATE_INTERVAL = 1
local updateIn = 0
local tooltipFrame = nil

local iconName = (UnitFactionGroup("player") == "Alliance") and "INV_Jewelry_TrinketPVP_01" or "INV_Jewelry_TrinketPVP_02"

local frame = CreateFrame("frame")
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local dataobj = ldb:NewDataObject("XToLevel", {
	type = "data source",
	icon = "Interface\\Icons\\" .. iconName,
	text = "XToLevel",
	label = "XToLevel",
})

local function FindAnchor(frame)
	local xcenter, ycenter = frame:GetCenter()
	if not xcenter or not ycenter then
		return "TOPLEFT", "BOTTOMLEFT" 
	end
	local hor = (xcenter > UIParent:GetWidth() * 2 / 3) and "RIGHT" or (xcenter < UIParent:GetWidth() / 3) and "LEFT" or ""
	local ver = (ycenter > UIParent:GetHeight() / 2) and "TOP" or "BOTTOM"
	
	--return ver..hor, frame, (ver == "TOP" and "BOTTOM" or "TOP")..hor
	return ver..hor, frame, (ver == "BOTTOM" and "TOP" or "BOTTOM")..hor
end

function dataobj:OnEnter()
	tooltipFrame = self
	local a1, f1, a2 = FindAnchor(self)
	ShowTooltip(self, a1, f1, a2, L['Click To Configure'])
end

function dataobj:OnLeave()
	tooltipFrame = nil
	GameTooltip:Hide()
end

function dataobj.OnClick(self, button)
	-- TODO: Do something more interesting here...
	cDisplay.Config:Open("ldb")
end

-- TODO: Rewrite the base regexp to use the HTML like syntax, and convert the base patterns.
function UpdateDataObject()
	if sConfig.ldb.showLabel then
		dataobj.label = L["XToLevel"]
	else
		dataobj.label = nil
	end
	
	if sConfig.ldb.showIcon then
		local iconName = (UnitFactionGroup("player") == "Alliance") and "INV_Jewelry_TrinketPVP_01" or "INV_Jewelry_TrinketPVP_02"
		dataobj.icon = "Interface\\Icons\\" .. iconName
	else
		dataobj.icon = nil
	end
	
	if sConfig.ldb.showText then
		if (cPlayer.level < cPlayer.maxLevel) or cPet.isActive or cPet.hasBeenActive then
			local showPlayer = (cPlayer.level < cPlayer.maxLevel)
			local showPet = cPet.isActive or cPet.hasBeenActive
			
			-- User is leveling, proceed normally.
			local playerProgress, playerProgressColor, petProgress, petProgressColor
			
			if showPlayer then
				playerProgress = round(cPlayer.currentXP / cPlayer.maxXP * 100, 1)
				playerProgressColor = GetProgressColor(playerProgress)
			end
				
			if showPet then
				petProgress = round(cPet.xp / cPet.maxXP * 100, 1)
				petProgressColor = GetProgressColor(petProgress)
			end
			
			-- Set up patterns. -- TODO: Place this in a seperate file?
			local patterns = {
				default = "{kills}{$seperator: }{color=cfcfdf}{$label}:{/color} {progress}{$value}{/progress}{/kills}{quests}{$seperator: }{color=cfcfdf}{$label}:{/color} {progress}{$value}{/progress}{/quests}{bgs}{$seperator: }{color=cfcfdf}{$label}:{/color} {progress}{$value}{/progress}{/bgs}{bgo}{$seperator: }{color=cfcfdf}{$label}:{/color} {progress}{$value}{/progress}{/bgo}{xp}{$seperator: }{progress}[{$value}]{/progress}{/xp}{pet}{$seperator: }{color=cfcfdf}{$label}:{/color} {progress}{$value}{/progress}{/pet}{petxp}{$seperator: }{progress}[{$value}]{/progress}{/petxp}",
				minimal = "{kills}{progress}{$value}{/progress}{/kills}{quests}{color=cfcfdf}{$seperator:/}{/color}{progress}{$value}{/progress}{/quests}{bgs}{color=cfcfdf}{$seperator:/}{/color}{progress}{$value}{/progress}{/bgs}{xp}{color=cfcfdf}{$seperator:/}{/color}{progress}{$value}{/progress}{/xp}{pet}{color=cfcfdf}{$seperator:/}{/color}{progress}{$value}{/progress}{/pet}{petxp}{color=cfcfdf}{$seperator:/}{/color}{progress}{$value}{/progress}{/petxp}",
				minimal_dashed = "{kills}{progress}{$value}{/progress}{/kills}{quests}{color=cfcfdf}{$seperator:-}{/color}{progress}{$value}{/progress}{/quests}{bgs}{color=cfcfdf}{$seperator:-}{/color}{progress}{$value}{/progress}{/bgs}{xp}{color=cfcfdf}{$seperator:-}{/color}{progress}{$value}{/progress}{/xp}{pet}{color=cfcfdf}{$seperator:-}{/color}{progress}{$value}{/progress}{/pet}{petxp}{color=cfcfdf}{$seperator:-}{/color}{progress}{$value}{/progress}{/petxp}",
				brackets = "{kills}{progress}[{$value}]{/progress}{/kills}{quests}{progress}[{$value}]{/progress}{/quests}{bgs}{progress}[{$value}]{/progress}{/bgs}{xp}{progress}[{$value}]{/progress}{/xp}{pet}{$seperator:-}{progress}[{$value}]{/progress}{/pet}{petxp}{progress}[{$value}]{/progress}{/petxp}",
			}
			
			-- Load the appropriate pattern, attempting to find one in the config.
			local newText = patterns.default
			if sConfig.ldb.textPattern ~= nil then
				if sConfig.ldb.textPattern == "custom" then
					newText = sData.customPattern or "Please enter a pattern."
					
					-- Parse html-like syntax
					newText = string.gsub(newText, '<(%w+) ?(.-)>', function(tag, attr)
						local sPos, ePost, value, rest, attributes, out;
					
						attributes = {
							label = false,
							post = false,
							seperator = false,
						}
						
						for key, value in pairs(attributes) do
							sPos, ePost, value, rest = string.find(attr, key ..'="([^"]-)"')
							if value ~= nil then
								attributes[key] = value
							end
						end
						
						out = "{".. tag .."}"
						if attributes.seperator then
							out = out .. "{$seperator:" .. attributes.seperator .."}"
						end
						if attributes.label then
							out = out .. attributes.label ..": "
						end
						out = out .. "{progress}{$value}"
						if attributes.post then
							out = out .. attributes.post or nil
						end
						out = out .. "{/progress}{/" .. tag .."}"
						return out
					end)
				else
					newText = patterns[sConfig.ldb.textPattern]
				end
			end
			
			-- Replace {color} tags
			if sConfig.ldb.allowTextColor then 
				newText = string.gsub(newText, "{color=([0-9A-Fa-f]+)}(.-){/color}", "|cFF%1%2|r")
			else
				newText = string.gsub(newText, "{color=[0-9A-Fa-f]+}(.-){/color}", "%1")

			end
			
			-- Prepare tags
			local useColors = (sConfig.ldb.allowTextColor and sConfig.ldb.text.colorValues)
			local tags = {
				[1] = { 
					tag = "kills",
					label = (sConfig.ldb.text.verbose and L["Kills"] ) or L["Kills Short"],
					value = (showPlayer and (round(cPlayer:GetAverageKillsRemaining()) or "~")) or nil,
					color = (useColors and playerProgressColor) or nil,
				},
				[2] = { 
					tag = "quests",
					label = (sConfig.ldb.text.verbose and L["Quests"] ) or L["Quests Short"],
					value = (showPlayer and (round(cPlayer:GetAverageQuestsRemaining()) or "~")) or nil,
					color = (useColors and playerProgressColor) or nil,
				}, 
				[3] = { 
					tag = "bgs",
					label = (sConfig.ldb.text.verbose and L["Battlegrounds"] ) or L["Battlegrounds Short"],
					value = ((showPlayer and UnitLevel("Player") >= 10) and round(cPlayer:GetAverageBGsRemaining())) or nil,
					color = (useColors and playerProgressColor) or nil,
				}, 
				[4] = { 
					tag = "bgo",
					label = (sConfig.ldb.text.verbose and L["Battleground Objectives"] ) or L["Battleground Objectives Short"],
					value = ((showPlayer and UnitLevel("Player") >= 10) and round(cPlayer:GetAverageBGObjectivesRemaining())) or nil,
					color = (useColors and playerProgressColor) or nil,
				}, 
				[5] = { 
					tag = "xp",
					label = (sConfig.ldb.text.verbose and L["XP"] ) or L["XP Short"],
					value = (showPlayer and ((playerProgress or "~") .. "%%")) or nil,
					color = (sConfig.ldb.allowTextColor and playerProgressColor) or nil,
				},
				[6] = { 
					tag = "pet",
					label = (sConfig.ldb.text.verbose and L["Pet"] ) or L["Pet Short"],
					value = (showPet and (round(cPet:GetAverageKillsRemaining()))) or nil,
					color = (useColors and petProgressColor) or nil,
				},
				[7] = { 
					tag = "petxp",
					label = (sConfig.ldb.text.verbose and L["XP"] ) or L["XP Short"],
					value = (showPet and ((petProgress or "~")  .. "%%")) or nil,
					color = (sConfig.ldb.allowTextColor and petProgressColor) or nil,
				},
			}
			
			-- Replace values
			local isFirst = true
			for i, object in ipairs(tags) do
				if sConfig.ldb.text[object.tag] and object.value ~= nil then
					newText = string.gsub(newText, "{".. object.tag .."}(.-){/".. object.tag .."}", function(str)
						str = string.gsub(str, "{$label}", object.label)
						str = string.gsub(str, "{$value}", object.value)
						if object.color ~= nil then
							str = string.gsub(str, "{progress}(.-){/progress}", "|cFF".. object.color .."%1|r")
						else
							str = string.gsub(str, "{progress}(.-){/progress}", "%1")
						end
						if isFirst then
							str = string.gsub(str, "{$seperator(.-)}", "")
						else
							str = string.gsub(str, "{$seperator:?(.-)}", "%1")
						end
						return str
					end)
					isFirst = false
				else
					newText = string.gsub(newText, "{".. object.tag .."}.-{/".. object.tag .."}", "")
				end
			end
			dataobj.text = newText
			
		else
			-- Player is at max level and has no pets.
			if sConfig.ldb.customColors then
				dataobj.text = "|cFFaaaaaaInactive|r"
			else
				dataobj.text = "Inactive"
			end
		end
	else
		dataobj.text = nil
	end
end

frame:SetScript("OnUpdate", function(self, elap)
	updateIn = updateIn - elap
	if updateIn <= 0 then
		updateIn = UPDATE_INTERVAL
		UpdateDataObject()
		
		if tooltipFrame then
			dataobj.OnEnter(tooltipFrame)
		end
	end
end)

function ShowTooltip(frame, a1, f1, a2, footerText)
	if frame ~= nil then
		GameTooltip:SetOwner(frame, "ANCHOR_NONE")
	end
	if a1 ~= nil or f1 ~= nil or a2 ~= nil then
		
		GameTooltip:SetPoint(a1, f1, a2)
	end
	
	GameTooltip:ClearLines()
	
	local labelColor, dataColor, footerColor
	
	if sConfig.ldb.allowTextColor then
		labelColor = { r=0.75, g=0.75, b=0.75 }
		dataColor = { r=0.9, g=1, b=0.9 }
		footerColor = { r=0.6, g=0.6, b=0.6 }
	else
		labelColor = {}
		dataColor = {}
		footerColor = {}
	end
	
	GameTooltip:AddLine("XToLevel")
	
	if cPlayer.level < cPlayer.maxLevel then
		if sConfig.ldb.tooltip.showDetails then
			GameTooltip:AddDoubleLine(L["Kills"] .. ":" , NumberFormat(cPlayer:GetAverageKillsRemaining()) .." @ ".. NumberFormat(round(cPlayer:GetAverageKillXP(), 0)) .." xp", labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
			GameTooltip:AddDoubleLine(L["Quests"] .. ":" , NumberFormat(cPlayer:GetAverageQuestsRemaining()) .." @ ".. NumberFormat(round(cPlayer:GetAverageQuestXP(), 0)) .." xp", labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
		end
		if ShowBattlegroundData() then
			GameTooltip:AddDoubleLine(L["Avrg Battlegrounds"] .. ":" , NumberFormat(cPlayer:GetAverageBGsRemaining() or 0) .." @ ".. NumberFormat(round(cPlayer:GetAverageBGXP(), 0)) .." xp", labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
			GameTooltip:AddDoubleLine(L["Avrg BG Objectives"] .. ":" , NumberFormat(cPlayer:GetAverageBGObjectivesRemaining() or 0) .." @ ".. NumberFormat(round(cPlayer:GetAverageBGObjectiveXP(), 0)) .." xp", labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
		end
		GameTooltip:AddLine(" ")
		
		if sConfig.ldb.tooltip.showExperience then
			local xpProgress = round((cPlayer.currentXP or 0) / (cPlayer.maxXP or 1) * 100, 1)
			local xpNeededTotal = cPlayer.maxXP - cPlayer.currentXP
			local xpNeededActual = cPlayer:GetKillsRequired(1) or "~"
			
			GameTooltip:AddLine(L["Experience Header"] .. ": ")
			GameTooltip:AddDoubleLine(" " .. L["XP Progress"] .. ": " , ShrinkNumber(UnitXP("player")) .. " / " .. ShrinkNumber(UnitXPMax("player")) .. " [" .. tostring(xpProgress) .. "%" .. "]", labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
			GameTooltip:AddDoubleLine(" " .. L["XP Rested"] .. ": " , NumberFormat(cPlayer:IsRested() or 0) .. " xp", labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
			GameTooltip:AddDoubleLine(" " .. L["Quest XP Required"] .. ": " , NumberFormat(xpNeededTotal) .. " xp", labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
			GameTooltip:AddDoubleLine(" " .. L["Kill XP Required"] .. ": " , NumberFormat(xpNeededActual) .. " xp", labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
			
			GameTooltip:AddLine(" ")
		end
	end
	
	if cPet.isActive or cPet.hasBeenActive then
		local xpProgress = cPet.xp / cPet.maxXP * 100
		GameTooltip:AddLine(L["Pet Header"] .. ":")
		GameTooltip:AddDoubleLine(" " .. L["XP Progress"] .. ":" , NumberFormat(round((cPet.xp or 0))).." / "..NumberFormat(round((cPet.maxXP or 0))).." ["..NumberFormat(round(xpProgress, 1)).."%]", labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
		GameTooltip:AddDoubleLine(" " .. L["Kill XP Required"] .. ":" , NumberFormat(round((cPet.maxXP or 0) - (cPet.xp or 0))) .. " xp", labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
		GameTooltip:AddDoubleLine(" " .. L["Kills"] .. ":" , NumberFormat(cPet:GetAverageKillsRemaining()).." @ "..NumberFormat(round(cPet:GetAverageKillXP(), 0)).." xp", labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)		
		GameTooltip:AddLine(" ")
	end
		
	if ShowBattlegroundData() then
		if (# sData.player.bgList) > 0 then
			local bgs = cPlayer:GetBattlegroundsListed()
			local latestData = cPlayer:GetLatestBattlegroundDetails();
			
			if bgs ~= nil then
				GameTooltip:AddLine(L['LDB Battlegrounds Required'] .. ":")
					for name, count in pairs(bgs) do
						if name == false then
							name = "Unknown"
						end
						local averageRaw = cPlayer:GetBattlegroundAverage(name)
						if averageRaw == 0 then
							averageRaw = latestData.totalXP
						end
						local averageFormatted = NumberFormat(round(averageRaw, 0))
						local needed = cPlayer:GetQuestsRequired(tonumber(averageRaw))
						GameTooltip:AddDoubleLine(" ".. name .. ": " , needed .. " @ ".. averageFormatted .. " xp", labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
					end
				GameTooltip:AddLine(" ")
			end
			
			
			
			if sData.player.bgList[1].inProgress then
				GameTooltip:AddLine(L['Current Battleground'] .. ":")
			else
				GameTooltip:AddLine(L['Last Battleground'] .. ":")
				if sData.player.bgList[1].name ~= false then
					GameTooltip:AddDoubleLine(" ".. L['Name'] ..": " , sData.player.bgList[1].name, labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
				end
			end
			
			GameTooltip:AddDoubleLine(" ".. L['Total XP'] ..": " , NumberFormat(latestData.totalXP), labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
			GameTooltip:AddDoubleLine(" ".. L['Objectives'] ..": " , NumberFormat(latestData.objCount) .." @ ".. NumberFormat(latestData.xpPerObj) .." xp", labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
			GameTooltip:AddDoubleLine(" ".. L['NPC Kills'] ..": " , NumberFormat(latestData.killCount) .." @ ".. NumberFormat(latestData.xpPerKill) .." xp", labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
			GameTooltip:AddLine(" ")
		else
			GameTooltip:AddLine(L['LDB Battlegrounds Required'] .. ":")
			GameTooltip:AddLine(" " .. L['No Battles Fought'], labelColor.r, labelColor.g, labelColor.b)
			GameTooltip:AddLine(" ")
		end
	end

	if footerText ~= nil then
		GameTooltip:AddLine(tostring(footerText), footerColor.r, footerColor.g, footerColor.b)
	end
	
	GameTooltip:Show()
end